%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7

%if 0%{?fedora} < 19
%global	rubyabi	1.9.1
%endif
%global	header_dir	%{ruby_vendorarchdir}
%global	ruby19	1
%else
%global	ruby_sitelib	%(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']")
%global	ruby_sitearch	%(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']")

%global	rubyabi	1.8
%global	header_dir	%{ruby_sitearch}
%global	ruby19	0
%endif

%global	gem_name	glib2

%global	obsoleteevr	0.90.7-1.999

Summary:	Ruby binding of GLib-2.x
Name:		rubygem-%{gem_name}
Version:	1.2.6
Release:	1%{?dist}
Group:		Development/Languages
# from README
License:	LGPLv2
URL:		http://ruby-gnome2.sourceforge.jp/
Source0:	http://rubygems.org/gems/%{gem_name}-%{version}.gem
# GLib::Completion removed on 1.2.6
Patch0:	rubygem-glib2-1.2.6-GLibCompletion-delete.patch
# F-19 %%_bindir/ruby wrapper pollutes environ, which makes
# g_spawn_async() test failure
Patch100:	rubygem-glib2-1.2.1-rubywrapper-pollutes-env.patch

%if 0%{?fedora} >= 19
Requires:	ruby(release)
# Explicitly require mri for g_spawn_async() test
BuildRequires:	%{_bindir}/ruby-mri
BuildRequires:	ruby(release)
%else
Requires:	ruby(abi) = %{rubyabi}
Requires:	ruby 
BuildRequires:	ruby(abi) = %{rubyabi}
BuildRequires:	ruby 
%endif
BuildRequires:	rubygems-devel
BuildRequires:	rubygem(pkg-config)
BuildRequires:	ruby-devel
BuildRequires:	glib2-devel
# For patch
#BuildRequires:	rubygem(rake-compiler)
## %%check
BuildRequires:	rubygem(test-unit)
Requires:	rubygems
# Ruby-GetText-Package support in glib2.rb
# Seems no longer needed
#Requires:	rubygem(gettext)
# If someone uses gnome2-win32-binary-downloader.rb, please explicitly
# require the following by yourself
#Requires:	rubygem(mechanize)
Provides:	rubygem(%{gem_name}) = %{version}

%if %{ruby19}
Obsoletes:	ruby-%{gem_name} <= %{version}-%{release}
Provides:	ruby-%{gem_name} = %{version}-%{release}
Provides:	ruby(%{gem_name}) = %{version}-%{release}
%endif

%description
Ruby/GLib2 is a Ruby binding of GLib-2.x.

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%package	-n ruby-%{gem_name}
Summary:	Non-Gem support package for %{gem_name}
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
# Requires for corresponsing non-gem rpms
Requires:	ruby(gettext-package)
Provides:	ruby(%{gem_name}) = %{version}-%{release}

%description	-n ruby-%{gem_name}
This package provides non-Gem support for %{gem_name}.

%package	devel
Summary:	Ruby/GLib development environment
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
Requires:	glib2-devel
Requires:	ruby-devel
# mkmf-gnome2.rb
Requires:	rubygem(pkg-config)
# gnome2-raketask.rb
Requires:	rubygem(rake-compiler)
# Not needed
#Requires:	rubygem(cairo)
# Obsoletes / Provides
# ruby(%%{gem_name}-devel) Provides is for compatibility
Obsoletes:	ruby-%{gem_name}-devel < %{obsoleteevr}
Provides:	ruby-%{gem_name}-devel = %{version}-%{release}
%if ! %{ruby19}
Provides:	ruby(%{gem_name}-devel) = %{version}-%{release}
%endif

%description devel
Header files and libraries for building a extension library for the
rubygem-%{gem_name}

%prep
%setup -q -c -T

TOPDIR=$(pwd)
mkdir tmpunpackdir
pushd tmpunpackdir

gem unpack %{SOURCE0}
cd %{gem_name}-%{version}

gem specification -l --ruby %{SOURCE0} > %{gem_name}.gemspec

# Patches and etc
%if 0%{?fedora} < 19
# Revert
%patch0 -p2 -R
grep -rl completion . | while read f
do
	ff=${f#./}
	sed -i \
		-e "\@s\.files@s|\"README\",|\"README\", \"$ff\",|" \
		%{gem_name}.gemspec
done
%endif
%patch100 -p1

# Make pkg-config devel dependency (not runtime)
sed -i \
	-e '\@pkg-config@s|add_\(runtime_\)*dependency|add_development_dependency|' \
	%{gem_name}.gemspec \
	Rakefile

sed -i \
	-e '2a require "rubygems"\ngem "test-unit"\n' \
	test/run-test.rb

# shebang issue
find sample/ test/ -name \*.rb | xargs chmod 0644
grep -rl '#![ ]*/usr' sample/ test/ | \
	xargs chmod 0755

# Repackage gem
gem build %{gem_name}.gemspec
mv %{gem_name}-%{version}.gem $TOPDIR

popd
rm -rf tmpunpackdir

%build
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
export CONFIGURE_ARGS="$CONFIGURE_ARGS --with-pkg-config-dir=$(pwd)%{_libdir}/pkgconfig"
%gem_install

# Move C extension library to some private directory
pushd .%{gem_instdir}
%if ! %{ruby19}
mkdir lib/ruby-gnome2
mv lib/%{gem_name}.so lib/ruby-gnome2/
grep -rl '%{gem_name}.so' . | \
	xargs sed -i \
		-e "\@require@s|'%{gem_name}.so'|'ruby-gnome2/%{gem_name}.so'|" \
		-e '\@require@s|"%{gem_name}.so"|"ruby-gnome2/%{gem_name}.so"|'
%endif

# create glib-test-init.rb
cat > lib/glib-test-init.rb <<EOF
\$VERBOSE = true
begin
	require 'rubygems'
	gem 'test-unit'
rescue LoadError
end
require 'test/unit'
EOF

%install
# Once copy all
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
	%{buildroot}%{gem_dir}/

pushd %{buildroot}
# move header files, C extension files to the correct directory
mkdir -p .%{header_dir}
mv .%{gem_instdir}/lib/*.h .%{header_dir}/

%if ! %{ruby19}
mkdir -p .%{ruby_sitearch}/ruby-gnome2
mv .%{gem_instdir}/lib/ruby-gnome2/%{gem_name}.so .%{ruby_sitearch}/ruby-gnome2/
%else
mkdir -p .%{gem_extdir_mri}/lib
mv .%{gem_instdir}/lib/%{gem_name}.so .%{gem_extdir_mri}/lib
%endif
popd

# move pkgconfig file
mkdir %{buildroot}%{_libdir}/pkgconfig
install -cpm 644 ./%{_libdir}/pkgconfig/*.pc \
	%{buildroot}%{_libdir}/pkgconfig/


# Cleanups
pushd %{buildroot}
rm -rf .%{gem_instdir}/ext/
rm -f .%{gem_instdir}/extconf.rb
popd

# The following method is completely copied from rubygem-gettext
# spec file
#
# Create symlinks
##
## Note that before switching to gem %%{ruby_sitelib}/%%{gem_name}
## already existed as a directory, so this cannot be replaced
## by symlink (cpio fails)
## Similarly, all directories under %%{ruby_sitelib} cannot be
## replaced by symlink
#

create_symlink_rec(){

ORIGBASEDIR=$1
TARGETBASEDIR=$2

## First calculate relative path of ORIGBASEDIR 
## from TARGETBASEDIR
TMPDIR=$TARGETBASEDIR
BACKDIR=
DOWNDIR=
num=0
nnum=0
while true
do
	num=$((num+1))
	TMPDIR=$(echo $TMPDIR | sed -e 's|/[^/][^/]*$||')
	DOWNDIR=$(echo $ORIGBASEDIR | sed -e "s|^$TMPDIR||")
	if [ x$DOWNDIR != x$ORIGBASEDIR ]
	then
		nnum=0
		while [ $nnum -lt $num ]
		do
			BACKDIR="../$BACKDIR"
			nnum=$((nnum+1))
		done
		break
	fi
done

RELBASEDIR=$( echo $BACKDIR/$DOWNDIR | sed -e 's|//*|/|g' )

## Next actually create symlink
pushd %{buildroot}/$ORIGBASEDIR
find . -type f | while read f
do
	DIRNAME=$(dirname $f)
	BACK2DIR=$(echo $DIRNAME | sed -e 's|/[^/][^/]*|/..|g')
	mkdir -p %{buildroot}${TARGETBASEDIR}/$DIRNAME
	LNNAME=$(echo $BACK2DIR/$RELBASEDIR/$f | \
		sed -e 's|^\./||' | sed -e 's|//|/|g' | \
		sed -e 's|/\./|/|' )
	ln -s -f $LNNAME %{buildroot}${TARGETBASEDIR}/$f
done
popd

}

%if ! %{ruby19}
create_symlink_rec %{gem_instdir}/lib %{ruby_sitelib}
%endif

%check
pushd .%{gem_instdir}

# Kill unneeded make process
mkdir -p TMPBINDIR
pushd TMPBINDIR
ln -sf /bin/true make
export PATH=$(pwd):$PATH
popd

ruby ./test/run-test.rb
popd

%files
%defattr(-,root,root,-)
%dir	%{gem_instdir}
%dir	%{gem_instdir}/lib/

%doc	%{gem_instdir}/[A-Z]*
%exclude	%{gem_instdir}/Rakefile

%{gem_instdir}/lib/glib2.rb
%{gem_instdir}/lib/glib-mkenums.rb
%dir %{gem_instdir}/lib/glib2
%{gem_instdir}/lib/glib2/deprecatable.rb

%if %{ruby19}
%dir	%{gem_extdir_mri}
%dir	%{gem_extdir_mri}/lib
%{gem_extdir_mri}/lib/%{gem_name}.so
%else
%dir	%{ruby_sitearch}/ruby-gnome2/
%{ruby_sitearch}/ruby-gnome2/%{gem_name}.so
%endif

%{gem_cache}
%{gem_spec}

%if ! %{ruby19}
%files	-n ruby-%{gem_name}
%defattr(-,root,root,-)
%{ruby_sitelib}/*.rb
%{ruby_sitelib}/glib2/
%exclude	%{ruby_sitelib}/glib-test-init.rb
%exclude	%{ruby_sitelib}/gnome2-raketask.rb
%exclude	%{ruby_sitelib}/mkmf-gnome2.rb
%exclude	%{ruby_sitelib}/gnome2-win32-binary-*.rb
%endif

%files	devel
%defattr(-,root,root,-)
# Using pkg-config and mkmf, let's move mkmf-gnome2.rb into -devel
# gnome2-raketask.rb uses rake-compiler, so also put this into -devel
# Also install gliglib-test-init.rb
%{gem_instdir}/lib/glib-test-init.rb
%{gem_instdir}/lib/gnome2-raketask.rb
%{gem_instdir}/lib/mkmf-gnome2.rb
%{gem_instdir}/lib/gnome2-win32-binary-*.rb
%if ! %{ruby19}
%{ruby_sitelib}/glib-test-init.rb
%{ruby_sitelib}/gnome2-raketask.rb
%{ruby_sitelib}/mkmf-gnome2.rb
%{ruby_sitelib}/gnome2-win32-binary-*.rb
%endif

%{header_dir}/rbgcompat.h
%{header_dir}/rbglib.h
%{header_dir}/rbglibdeprecated.h
%{header_dir}/rbglib2conversions.h
%{header_dir}/rbgobject.h
%{header_dir}/rbgutil.h
%{header_dir}/rbgutil_list.h
%{header_dir}/rbgutildeprecated.h
%{header_dir}/glib-enum-types.h
%{_libdir}/pkgconfig/ruby-%{gem_name}.pc

%files	doc
%defattr(-,root,root,-)
%{gem_docdir}/
%{gem_instdir}/Rakefile
%{gem_instdir}/sample/
%{gem_instdir}/test/


%changelog
* Wed Apr 17 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.6-1
- 1.2.6

* Thu Apr  4 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.5-1
- 1.2.5

* Tue Mar 26 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.4-1
- 1.2.4

* Wed Mar 20 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.3-1
- 1.2.3

* Thu Feb 28 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.1-4
- F-19: Explicitly require mri for g_spawn_async() test

* Thu Feb 28 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.1-3
- Workaround patch for test failure with ruby 2.0.0

* Wed Feb 27 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.1-2
- F-19: Rebuild for ruby 2.0.0

* Mon Feb  4 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.1-1
- 1.2.1

* Wed Jan 30 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.0-1
- 1.2.0

* Mon Dec 31 2012 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.1.9-1
- 1.1.9

* Thu Dec  6 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.6-1
- 1.1.6

* Wed Sep  5 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.5-1
- 1.1.5

* Mon Aug 13 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.4-1
- 1.1.4

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.1.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Apr 16 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.3-1
- 1.1.3

* Tue Apr 03 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1.1.2-6
- Fix conditionals for F17 to work for RHEL 7 as well.

* Tue Mar 27 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.2-5
- Fix UTF-{16,32} related test failure on ppc{,64}
  (bug 804319, upstream bug 107)

* Fri Mar 23 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.2-4
- Fix build error with GLib >= 2.31.20 (bug 804319, upstream bug 106)

* Wed Feb  1 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.2-3
- Add proper Obsoletes/Provides

* Sun Jan 29 2012 Mamoru Tasaka <mtasaka@fedoraproject.org>
- And rebuild for ruby 1.9

* Sun Jan 29 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.2-1
- 1.1.2

* Sun Jan 15 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.1.1-1
- 1.1.1

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.3-3
- F-17: Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Thu Dec  1 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.0.3-2
- Workaround on build issue and test suite with GLib 2.31.2

* Mon Sep 19 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.0.3-1
- 1.0.3

* Fri Jul 15 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.0.0-1
- 1.0.0

* Sun Jun 12 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 0.90.9-1
- 0.90.9

* Fri Mar 18 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 0.90.8-2
- Fix files list
- Patch for newer rake (>= 0.9.0 beta.2) to make GNOME2Package.task succeed

* Fri Mar  5 2011 Mamoru Tasaka <mtasaka@fedoraproject.org> - 0.90.8-1
- 0.90.8

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.90.7-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Feb  9 2011 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.7-3
- 0.90.7
- Create "glib-test-init.rb" for testsuite on other ruby-gnome2 related
  gems

* Sun Oct 31 2010 Mamoru Taska  <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.5-3
- 0.90.5
- Move C extension so that "require %%gem_name" works correctly

* Sun Oct 24 2010 Mamoru Taska  <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.4-2
- 0.90.4

* Sun Oct 24 2010 Mamoru Taska  <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.3-2
- 0.90.3

* Fri Oct  1 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.2-6
- Fix up summary

* Fri Oct  1 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.2-5
- Use formally released gem file

* Tue Sep 28 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.2-4
- Modify Obsoletes
- Fix %%description

* Mon Sep 27 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.2-2
- 0.90.2 released, release bump

* Sun Sep 26 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.90.2-0.1
- Initial package
